//
//  ListRightVariableTotalDataModel.swift
//  MVMCoreUI
//
//  Created by Kruthika KP on 02/03/20.
//  Copyright © 2020 Verizon Wireless. All rights reserved.
//


public class ListRightVariableTotalDataModel: ListItemModel, MoleculeModelProtocol {
    //--------------------------------------------------
    // MARK: - Properties
    //--------------------------------------------------
    
    public static var identifier: String = "listRVLine"
    public var leftLabel: LabelModel
    public var rightLabel: LabelModel
    public var bar: LineModel
    
    //--------------------------------------------------
    // MARK: - Method
    //--------------------------------------------------
    
    override public func setDefaults() {
        super.setDefaults()
        rightLabel.hero = 0
        bar.type = .heavy
        
        if bar.backgroundColor == nil {
            bar.backgroundColor = Color(uiColor: .mvmBlue)
        }
    }
    
    //--------------------------------------------------
    // MARK: - Initializer
    //--------------------------------------------------
    
    public init(leftLabel: LabelModel, rightlabel:LabelModel, bar: LineModel){
        self.leftLabel = leftLabel
        self.rightLabel = rightlabel
        self.bar = bar
        super.init()
    }
    
    //--------------------------------------------------
    // MARK: - Keys
    //--------------------------------------------------
    
    private enum CodingKeys: String, CodingKey{
        case moleculeName
        case leftLabel
        case rightLabel
        case bar
    }
    
    //--------------------------------------------------
    // MARK: - Codec
    //--------------------------------------------------
    
    required public init(from decoder: Decoder) throws {
        let typeContainer = try decoder.container(keyedBy: CodingKeys.self)
        leftLabel = try typeContainer.decode(LabelModel.self, forKey: .leftLabel)
        rightLabel = try typeContainer.decode(LabelModel.self, forKey: .rightLabel)
        bar = try typeContainer.decode(LineModel.self, forKey: .bar)
        try super.init(from: decoder)
    }
    
    public  override func encode(to encoder: Encoder) throws {
        try super.encode(to: encoder)
        var container = encoder.container(keyedBy: CodingKeys.self)
        try container.encode(moleculeName, forKey: .moleculeName)
        try container.encode(leftLabel, forKey: .leftLabel)
        try container.encode(rightLabel, forKey: .rightLabel)
        try container.encode(bar, forKey: .bar)
    }
}
